#!/bin/bash --norc
set -o pipefail
set -ef
# note: bash-dependent, see checkbashisms

export LC_ALL=C
verbose=
OPTIONS=
LONGOPTIONS=
REPOSITORY_BRANCH="sisyphus"
# alt system gits
git_default_url=git://git.altlinux.org
# alt system web shared tasks
web_default_tasks_url=http://git.altlinux.org
WEBERY_HOST=
WEB_TASKS_URL=
# alt personal gits
gitery_default_url=git://gitery.altlinux.org
gitery_default_host=
GITERY_HOST=
GIRAR_HOST=
DRY_RUN=
TASK=
SUBTASK=100
taskarch=`uname -m`
case $taskarch in
    i?86|athlon*)
    taskarch=i586
    ;;
esac

for config_file in /etc/girar-nmu/default ${XDG_CONFIG_HOME:-$HOME/.config}/girar-nmu/default; do
    ! [ -e "$config_file" ] || . "$config_file"
done
# --- autodetection in absence of config file ---
if [ -z "$gitery_default_host" ]; then
    if grep -E '^Host[[:space:]]+gitery[[:space:]]*$' ~/.ssh/config >/dev/null; then
	gitery_default_host=gitery
    elif grep -E '^Host[[:space:]]+git.alt[[:space:]]*$' ~/.ssh/config >/dev/null; then
	gitery_default_host=git.alt
    else
	gitery_default_host=gitery
    fi
fi
if [ -z "$GIRAR_HOST" ]; then
    if grep -E '^Host[[:space:]]+girar[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=girar
    elif grep -E '^Host[[:space:]]+gyle[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=gyle
    elif grep -E '^Host[[:space:]]+gyle.alt[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=gyle.alt
    elif grep -E '^Host[[:space:]]+sborochnitsa[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=sborochnitsa
    else
	GIRAR_HOST=girar
    fi
fi
# --- end autodetection ---------------------------


OPTIONS=s:t:''a:
LONGOPTIONS=,task:,subtask:,arch:
# not compatible with set -e
#getopt --test > /dev/null; #if [ "$?" -ne 4 ]; then
if getopt --test > /dev/null; then
    echo "Oops! `getopt --test` not failed. Bad getopt!." >&2
    exit 1
fi
__OPTS=hqVvb:H:P:R:
__LONGOPTS=dry-run,help,quiet,verbose,version,branch:,girar:,gyle:,gitery:,git.alt:,profile:,webery:,web_tasks_url:
PARSED=$(getopt --options=$__OPTS$OPTIONS --longoptions=$__LONGOPTS$LONGOPTIONS --name "$0" -- "$@")
if [ "$?" -ne 0 ]; then
    exit 2
fi
eval set -- "$PARSED"
while true; do
    case "$1" in
	-t|--task) TASK="$2"
	    readonly TASK
            shift 2 ;;
	-s|--subtask) SUBTASK="$2"
	    readonly SUBTASK
            shift 2 ;;
	-P|--profile)
	    local profile_file="$2"
	    for config_file in /etc/girar-nmu/"$profile_file" ${XDG_CONFIG_HOME:-$HOME/.config}/girar-nmu/"$profile_file"; do
		! [ -e "$config_file" ] || . "$config_file"
	    done
            shift 2 ;;
        -q|--quiet)
            verbose=
            shift ;;
        -V|--version)
            echo "2.015.2"
	    exit 0
            shift ;;
        -v|--verbose)
            verbose=$(($verbose+1))
            shift ;;
	-h|--help)
	    pod2usage --exit=0 "$0";
	    exit 0 ;;
	-b|--branch)
	    REPOSITORY_BRANCH="$2"
	    readonly REPOSITORY_BRANCH
            shift 2 ;;
	-H|--gitery|--git.alt)
	    GITERY_HOST="$2"
	    readonly GITERY_HOST
            shift 2 ;;
	-R|--girar|--gyle)
	    GIRAR_HOST="$2"
	    readonly GIRAR_HOST
            shift 2 ;;
	-W|--webery)
	    WEBERY_HOST="$2"
	    readonly WEBERY_HOST
            shift 2 ;;
	--web-tasks-url)
	    WEB_TASKS_URL="$2"
	    readonly WEB_TASKS_URL
            shift 2 ;;
        --dry-run)
            DRY_RUN=echo
            shift ;;
        --)
            shift
            break
            ;;
        *)
	    echo "Internal error: Unexpected option: $1 $2" >&2
	    #pod2usage --exit=3 "$0"
            exit 3
            ;;
	-a|--arch)
	    taskarch="$2"
	    readonly taskarch
            shift 2 ;;
    esac
done

if [ -z "$WEB_TASKS_URL" ] && [ -n "$WEBERY_HOST" ]; then
   WEB_TASKS_URL="http://$WEBERY_HOST"
fi

#---------------------------------------------
[ -n "$1" ] && TASK=$1
[ -n "$2" ] && SUBTASK=$2
if [ -z "$TASK" ]; then
    TASK=`ssh $GIRAR_HOST task ls | head -1 | awk '{print $1}' | sed 's,^#,,'`
    if ! [ "$TASK" -gt 0 ]; then
	echo 'Error: task number is mandatory'
	exit 1
    fi
fi
#---------------------------------------------

[ 0"$verbose" -ge 3 ] && set -x ||:
rpmsurl="${WEB_TASKS_URL:-$web_default_tasks_url}/tasks/$TASK/build/$SUBTASK/$taskarch/rpms/"
rpmspage=`curl -s $rpmsurl`
if [ -z "$rpmspage" ] || [[ "$rpmspage" == *'404 Not Found'* ]]; then
    echo 'Error: no rpms in '$rpmsurl
    exit 3
fi
echo found:
echo "$rpmspage" | grep 'HREF=".*\.rpm"' | sed 's,^.*HREF="\([^"]*\.rpm\)".*,\1,'

echo "$rpmspage" | grep 'HREF=".*\.rpm"' | sed 's,^.*HREF="\([^"]*\.rpm\)".*,\1,' | \
    $DRY_RUN wget -i- --base ${WEB_TASKS_URL:-$web_default_tasks_url}:/tasks/$TASK/build/$SUBTASK/$taskarch/rpms/

: <<'__EOF__'

=head1	NAME

girar-download-task-binary-rpms - download built binary rpms from a girar task

=head1	SYNOPSIS

B<girar-download-task-binary-rpms>
[B<-t|--task> task]
[B<-s|--subtask> subtask]
[B<-H|--gitery> I<ssh gitery alias>]
[B<-R|--girar> I<ssh girar(gule) alias>]
[B<-W|--webery> I<tasks web site>]
[B<--web-tasks-url> I<tasks web site url>]
[B<-b|--branch> I<repository>]
[B<--dry-run>]
[B<-P|--profile> I<profile>]
[B<-h|--help>]
[B<-v|--verbose>]
[B<-q|--quiet>]

[B<-a|--arch> I<arch>]
[<task> [<subtask>]]

=head1	DESCRIPTION

B<girar-download-task-binary-rpms> [<task> [<subtask>]] -
download built binary rpms from a girar task. Default subtask is 100.

=head1	OPTIONS

=over

=item	B<-a|--arch> I<arch>

rpm arch to download. Default is `uname -m`.

=item	B<-t|--task> I<task>

Task number. Mandatory. By default, the first arg is considered a task number.

=item	B<-s|--subtask> I<subtask>

Subtask number.
Default is 100.

=item	B<-b|--branch> I<repository branch>

Name of the repository branch. Values: sisyphus|p8|..
Default is sisyphus.

=item	B<-R|--girar> I<girar(gyle) ssh alias>

By default, gyle.altlinux.org account should be configured as girar or gyle in ~/.ssh/config.
If you do not follow that convention, use -R <your girar ssh alias> option.

=item	B<-H|--gitery> I<gitery ssh alias>

Alternative gitery or ssh alias for gitery, for example, git.e2k.
If not specified, by default, gitery is used where ssh account is
required and git.altlinux.org is used where http:// is enough.

=item	B<-W|--webery> I<tasks web site>

Alternative site that hosts girar tasks.
If not specified, by default, git.altlinux.org is used.

=item	[B<--web-tasks-url> I<tasks web site url>]

The default URL for web task site is http://I<tasks web site>.
See --webery for details. B<--web-tasks-url> overrides this URL.

=item	B<--dry-run>

Echo state-changing commands instead of doing them. An extra safety.
Also a bit useful for debugging.

=item	B<-P|--profile> I<profile>

Name of the configuration profile. The profile is loaded as
/etc/girar-nmu/I<profile> and $HOME/.config/girar-nmu/I<profile>.
Note that default configuration is stored in
/etc/girar-nmu/default and $HOME/.config/girar-nmu/default.

=item	B<-V|--version>

Print version and exit.

=item	B<-v|--verbose>

Verbose. Prints extra information. Multiple -v accumulate.
-v -v -v set debug mode (set -x).

=item	B<-q|--quiet>

Quiet. Print no warnings.

=item	B<-h|--help>

Display this help and exit.


=back

=head1	AUTHOR

Written by Igor Vlasenko <viy@altlinux.org>.

=head1	COPYING

Copyright (c) 2010-2022 Igor Vlasenko, ALT Linux Team.

This is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

=cut

__EOF__
